%define anolis_release 1
Name:           conntrack-tools
Version:        1.4.8
Release:        %{anolis_release}%{?dist}
Summary:        Manipulate netfilter connection tracking table and run High Availability
License:        GPL-2.0-only
URL:            http://conntrack-tools.netfilter.org/
Source0:        http://netfilter.org/projects/%{name}/files/%{name}-%{version}.tar.xz
Source1:        http://netfilter.org/projects/%{name}/files/%{name}-%{version}.tar.xz.sig
Source2:        NetfilterCoreTeam-OpenGPG-KEY.txt
Source3:        conntrackd.service
Source4:        conntrackd.conf

Patch0001:      0001-conntrack-ct-label-update-requires-proper-ruleset.patch
Patch0002:      0002-conntrack-don-t-print-USERSPACE-information-in-case-.patch
Patch0003:      0003-conntrackd-prevent-memory-loss-if-reallocation-fails.patch
Patch0004:      0004-conntrackd-exit-with-failure-status.patch
Patch0005:      0005-conntrackd-Fix-signal-handler-race-condition.patch
Patch0006:      0006-conntrackd-helpers-rpc-Don-t-add-expectation-table-e.patch
Patch0007:      0007-conntrack-tcp-fix-parsing-of-tuple-port-src-and-tupl.patch
Patch0008:      0008-conntrack-L-doesn-t-take-a-value-so-don-t-discard-on.patch
Patch0009:      0009-tests-conntrack-missing-space-before-option.patch
Patch0010:      0010-conntrack-improve-secmark-id-zone-parser.patch
Patch0011:      0011-conntrack-improve-mark-parser.patch
Patch0012:      0012-conntrack-Fix-for-ENOENT-in-mnl_nfct_delete_cb.patch
Patch0013:      0013-src-Eliminate-warnings-with-Wcalloc-transposed-args.patch

BuildRequires:  autoconf
BuildRequires:  automake
BuildRequires:  libtool
BuildRequires:  gcc
BuildRequires: gnupg2
BuildRequires:  libnfnetlink-devel >= 1.0.1, libnetfilter_conntrack-devel >= 1.0.9
BuildRequires:  libnetfilter_cttimeout-devel >= 1.0.0, libnetfilter_cthelper-devel >= 1.0.0
BuildRequires:  libmnl-devel >= 1.0.3, libnetfilter_queue-devel >= 1.0.2
BuildRequires:  libtirpc-devel systemd-devel
BuildRequires:  pkgconfig bison flex
Provides:       conntrack = 1.0-1
Obsoletes:      conntrack < 1.0-1
Requires(post): systemd
Requires(preun): systemd
Requires(postun): systemd
BuildRequires: systemd
BuildRequires: make

%description
With conntrack-tools you can setup a High Availability cluster and
synchronize conntrack state between multiple firewalls.

The conntrack-tools package contains two programs:
- conntrack: the command line interface to interact with the connection
             tracking system.
- conntrackd: the connection tracking userspace daemon that can be used to
              deploy highly available GNU/Linux firewalls and collect
              statistics of the firewall use.

conntrack is used to search, list, inspect and maintain the netfilter
connection tracking subsystem of the Linux kernel.
Using conntrack, you can dump a list of all (or a filtered selection  of)
currently tracked connections, delete connections from the state table,
and even add new ones.
In addition, you can also monitor connection tracking events, e.g.
show an event message (one line) per newly established connection.

%prep
%{gpgverify} --keyring='%{SOURCE2}' --signature='%{SOURCE1}' --data='%{SOURCE0}'
%autosetup -p1

%build
autoreconf -fi
%configure --disable-static --enable-systemd
%make_build
chmod 644 doc/sync/primary-backup.sh
rm -f doc/sync/notrack/conntrackd.conf.orig doc/sync/alarm/conntrackd.conf.orig doc/helper/conntrackd.conf.orig

%install
%make_install
find %{buildroot} -type f -name "*.la" -exec rm -f {} ';'
mkdir -p %{buildroot}%{_sysconfdir}/conntrackd
install -d -m 0755 %{buildroot}%{_unitdir}
install -m 0644 %{SOURCE3} %{buildroot}%{_unitdir}/
install -m 0644 %{SOURCE4} %{buildroot}%{_sysconfdir}/conntrackd/

%files
%license COPYING
%doc AUTHORS TODO doc
%dir %{_sysconfdir}/conntrackd
%config(noreplace) %{_sysconfdir}/conntrackd/conntrackd.conf
%{_unitdir}/conntrackd.service
%{_sbindir}/conntrack
%{_sbindir}/conntrackd
%{_sbindir}/nfct
%{_mandir}/man5/*
%{_mandir}/man8/*
%dir %{_libdir}/conntrack-tools
%{_libdir}/conntrack-tools/*

%post
%systemd_post conntrackd.service

%preun
%systemd_preun conntrackd.service

%postun
%systemd_postun conntrackd.service

%changelog
* Fri Feb 28 2025 Zhao Hang <wb-zh951434@alibaba-inc.com> - 1.4.8-1
- Refer to CentOS Stream conntrack-tools-1.4.8-3 (psutter@redhat.com)

* Tue Apr 11 2023 chen_yu_ao <m15927509890@163.com> - 1.4.7-2
- change spec file format

* Wed Jan 4 2023 Funda Wang <fundawang@yeah.net> - 1.4.7-1
- New version 1.4.7

* Fri Mar 11 2022 Chunmei Xu <xuchunmei@linux.alibaba.com> - 1.4.6-1
- init from usptream 1.4.6
